﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Biclustering
{
    public class Genetico
    {
        int[,] datos;
        public int nIndividuos;
        public int nGeneraciones;
        public int pMutacion;
        public int pCruza;
        public int pSeleccion;
      
        public Genetico(int[,] datos)
        {
            this.datos = datos;
            nIndividuos = 100;
            nGeneraciones = 100;
            pSeleccion = 90;
            pCruza = 70;
            pMutacion = 30;
        }
        
        public Cluster ejecutar()
        {
            Poblacion poblacion = new Poblacion(datos, nIndividuos);
            for (int nG = 0; nG < nGeneraciones; nG++)
            {
                poblacion.calculaFrentes();
                poblacion.seleccion(pSeleccion);
                poblacion.cruza(pCruza);
                poblacion.mutacion(pMutacion);
                Cluster mejorCluster = poblacion.mejorCluster;
                string cadena = nG.ToString() + "   ";
                cadena += mejorCluster.similaridad.ToString("F3") + "   ";
                cadena += mejorCluster.numGenes().ToString("F0") + "   ";
                cadena+= mejorCluster.numCondiciones().ToString("F0")+ "   ";
                cadena +=  (mejorCluster.similaridad/(mejorCluster.numGenes()*mejorCluster.numCondiciones())).ToString("F3") + "   ";
                cadena += mejorCluster.calculoMSR().ToString("F3");
                Console.WriteLine(cadena);
            }
            return poblacion.mejorCluster;
        }
    }
}
